var startOfMeasuredTime = 0;
function startMeasuringTime() {
  startOfMeasuredTime = (new Date()).getTime();
}

function stopMeasuringTime(msg) {
  var now = (new Date()).getTime();

  var seconds = (now - startOfMeasuredTime);

  if (msg) {
    if (seconds < 10) seconds = "  " + seconds;
    else if (seconds < 100) seconds = " " + seconds;
    console.log(seconds + "ms for " + msg);
  }
  return seconds;
}

var numVertices = 100000;

startMeasuringTime();

var flatArray1 = new Array();
var flatArray2 = new Array();
var flatArray3 = new Array();

for(var i=0; i<numVertices; i++) {
  flatArray1.push(1, 2, 3);
  flatArray2.push(4, 5, 6);
  flatArray3.push(0, 0, 0);
}

var alloc = stopMeasuringTime();
startMeasuringTime();

var as = flatArray1;
var bs = flatArray2;
var cs = flatArray3;

for(var i=0; i<numVertices; i+=3) {
  cs[i  ] = as[i  ] + bs[i  ];
  cs[i+1] = as[i+1] + bs[i+1];
  cs[i+2] = as[i+2] + bs[i+2];
  var len = Math.sqrt(cs[i]*cs[i] + cs[i+1]*cs[i+1] + cs[i+2]*cs[i+2]);
  if (len > 0) {
    cs[i  ] /= len;
    cs[i+1] /= len;
    cs[i+2] /= len;
  }

  cs[i  ] *= 5;
  cs[i+1] *= 5;
  cs[i+2] *= 5;
}

var webglBuffer = new Float32Array(cs);

var compute = stopMeasuringTime();
var total = alloc + compute;
console.log("FlatArray", alloc, compute, total);