var startOfMeasuredTime = 0;
function startMeasuringTime() {
  startOfMeasuredTime = (new Date()).getTime();
}

function stopMeasuringTime(msg) {
  var now = (new Date()).getTime();

  var seconds = (now - startOfMeasuredTime);

  if (msg) {
    if (seconds < 10) seconds = "  " + seconds;
    else if (seconds < 100) seconds = " " + seconds;
    console.log(seconds + "ms for " + msg);
  }
  return seconds;
}

var numVertices = 100000;

startMeasuringTime();

var flatArray1 = new Float32Array(numVertices * 3);
var flatArray2 = new Float32Array(numVertices * 3);
var flatArray3 = new Float32Array(numVertices * 3);

for(var i=0; i<numVertices; i++) {
  flatArray1[i*3  ] = 1;
  flatArray1[i*3+1] = 2;
  flatArray1[i*3+2] = 3;
  flatArray2[i*3  ] = 4;
  flatArray2[i*3+1] = 5;
  flatArray2[i*3+2] = 6;
  flatArray3[i*3  ] = 0;
  flatArray3[i*3+1] = 0;
  flatArray3[i*3+2] = 0;
}


var alloc = stopMeasuringTime();
startMeasuringTime();

var as = flatArray1;
var bs = flatArray2;
var cs = flatArray3;

for(var i=0; i<numVertices; i+=3) {
  cs[i] = as[i] + bs[i];
  cs[i] = as[i] + bs[i];
  cs[i] = as[i] + bs[i];
  var len = Math.sqrt(cs[i]*cs[i] + cs[i+1]*cs[i+1] + cs[i+2]*cs[i+2]);
  if (len > 0) {
    cs[i  ] /= len;
    cs[i+1] /= len;
    cs[i+2] /= len;
  }

  cs[i] *= 5;
  cs[i] *= 5;
  cs[i] *= 5;
}

var webglBuffer = cs;

var compute = stopMeasuringTime();
var total = alloc + compute;
console.log("FlatTypedArray", alloc, compute, total);