var startOfMeasuredTime = 0;
function startMeasuringTime() {
  startOfMeasuredTime = (new Date()).getTime();
}

function stopMeasuringTime(msg) {
  var now = (new Date()).getTime();

  var seconds = (now - startOfMeasuredTime);

  if (msg) {
    if (seconds < 10) seconds = "  " + seconds;
    else if (seconds < 100) seconds = " " + seconds;
    console.log(seconds + "ms for " + msg);
  }
  return seconds;
}

function Vec3BTAArray(n) {
  this.bufStorage = new ArrayBuffer(3 * n * 4);
  this.buf = new Float32Array(this.bufStorage, 0, 3 * n);
  for(var i=0; i<n; i++) {
    this[i] = new Float32Array(this.bufStorage, i * 3 * 4, 3);
  }
}

var Vec3BTA = {};

Vec3BTA.set = function(out, x, y, z) {
  out[0] = x;
  out[1] = y;
  out[2] = z;
}

Vec3BTA.fromValues = function(x, y, z) {
  return new Float32Array([x, y, z]);
}

Vec3BTA.add = function(out, a, b) {
  out[0] = a[0] + b[0];
  out[1] = a[1] + b[1];
  out[2] = a[2] + b[2];
}

Vec3BTA.normalize = function(out) {
  var len = Math.sqrt(out[0] * out[0] + out[1] * out[1] + out[2] * out[2]);
  if (len > 0) {
    out[0] /= len;
    out[1] /= len;
    out[2] /= len;
  }
  return out;
}

Vec3BTA.scale = function(out, f) {
  out[0] *= f;
  out[1] *= f;
  out[2] *= f;
}

var numVertices = 100000;

startMeasuringTime();

var vec3BufferedTypedArray1 = new Vec3BTAArray(numVertices);
var vec3BufferedTypedArray2 = new Vec3BTAArray(numVertices);
var vec3BufferedTypedArray3 = new Vec3BTAArray(numVertices);

for(var i=0; i<numVertices; i++) {
  Vec3BTA.set(vec3BufferedTypedArray1[i], 1, 2, 3);
  Vec3BTA.set(vec3BufferedTypedArray2[i], 4, 5, 6);
  Vec3BTA.set(vec3BufferedTypedArray3[i], 0, 0, 0);
}

var alloc = stopMeasuringTime();
startMeasuringTime();

var as = vec3BufferedTypedArray1;
var bs = vec3BufferedTypedArray2;
var cs = vec3BufferedTypedArray3;

for(var i=0; i<numVertices; i++) {
  Vec3BTA.add(cs[i], as[i], bs[i]);
  Vec3BTA.normalize(cs[i]);
  Vec3BTA.scale(cs[i], 5);
}

var webglBuffer = vec3BufferedTypedArray3.buf;

var compute = stopMeasuringTime();
var total = alloc + compute;
console.log("BufferedTypedArray", alloc, compute, total);