var startOfMeasuredTime = 0;
function startMeasuringTime() {
  startOfMeasuredTime = (new Date()).getTime();
}

function stopMeasuringTime(msg) {
  var now = (new Date()).getTime();

  var seconds = (now - startOfMeasuredTime);

  if (msg) {
    if (seconds < 10) seconds = "  " + seconds;
    else if (seconds < 100) seconds = " " + seconds;
    console.log(seconds + "ms for " + msg);
  }
  return seconds;
}

var Vec3TA = {};

Vec3TA.fromValues = function(x, y, z) {
  return new Float32Array([x, y, z]);
}

Vec3TA.add = function(out, a, b) {
  out[0] = a[0] + b[0];
  out[1] = a[1] + b[1];
  out[2] = a[2] + b[2];
}

Vec3TA.normalize = function(out) {
  var len = Math.sqrt(out[0] * out[0] + out[1] * out[1] + out[2] * out[2]);
  if (len > 0) {
    out[0] /= len;
    out[1] /= len;
    out[2] /= len;
  }
  return out;
}

Vec3TA.scale = function(out, f) {
  out[0] *= f;
  out[1] *= f;
  out[2] *= f;
}

var numVertices = 100000;

startMeasuringTime();

var vec3TypedArray1 = new Array();
var vec3TypedArray2 = new Array();
var vec3TypedArray3 = new Array();
var vec3TypedArray3WebglBuffer = new Float32Array(numVertices*3);

for(var i=0; i<numVertices; i++) {
  vec3TypedArray1[i] = Vec3TA.fromValues(1, 2, 3);
  vec3TypedArray2[i] = Vec3TA.fromValues(4, 5, 6);
  vec3TypedArray3[i] = Vec3TA.fromValues(0, 0, 0);
}

var alloc = stopMeasuringTime();
startMeasuringTime();

var as = vec3TypedArray1;
var bs = vec3TypedArray2;
var cs = vec3TypedArray3;
var webglBuffer = vec3TypedArray3WebglBuffer;

for(var i=0; i<numVertices; i++) {
  Vec3TA.add(cs[i], as[i], bs[i]);
  Vec3TA.normalize(cs[i]);
  Vec3TA.scale(cs[i], 5);
}

cs.forEach(function(v, i) {
  webglBuffer[i*3+0] = v[0];
  webglBuffer[i*3+1] = v[1];
  webglBuffer[i*3+2] = v[2];
});

var compute = stopMeasuringTime();
var total = alloc + compute;
console.log("Vec3TypedArrays", alloc, compute, total);