var startOfMeasuredTime = 0;
function startMeasuringTime() {
  startOfMeasuredTime = (new Date()).getTime();
}

function stopMeasuringTime(msg) {
  var now = (new Date()).getTime();

  var seconds = (now - startOfMeasuredTime);

  if (msg) {
    if (seconds < 10) seconds = "  " + seconds;
    else if (seconds < 100) seconds = " " + seconds;
    console.log(seconds + "ms for " + msg);
  }
  return seconds;
}

function Vec3IP(x, y, z) {
  this.x = x;
  this.y = y;
  this.z = z;
  return this;
}

Vec3IP.add = function(out, a, b) {
  out.x = a.x + b.x;
  out.y = a.y + b.y;
  out.z = a.z + b.z;
}

Vec3IP.normalize = function(out) {
  var len = Math.sqrt(out.x * out.x + out.y * out.y + out.z * out.z);
  if (len > 0) {
    out.x /= len;
    out.y /= len;
    out.z /= len;
  }
  return out;
}

Vec3IP.scale = function(out, f) {
  out.x *= f;
  out.y *= f;
  out.z *= f;
}

var numVertices = 100000;

startMeasuringTime();

var xyzInPlace1 = new Array();
var xyzInPlace2 = new Array();
var xyzInPlace3 = new Array();
var xyzInPlaceWebglBuffer = new Float32Array(numVertices*3);

for(var i=0; i<numVertices; i++) {
  xyzInPlace1[i] = new Vec3IP(1, 2, 3);
  xyzInPlace2[i] = new Vec3IP(4, 5, 6);
  xyzInPlace3[i] = new Vec3IP(0, 0, 0);
}

var alloc = stopMeasuringTime();
startMeasuringTime();

var as = xyzInPlace1;
var bs = xyzInPlace2;
var cs = xyzInPlace3;
var webglBuffer = xyzInPlaceWebglBuffer;

for(var i=0; i<numVertices; i++) {
  Vec3IP.add(cs[i], as[i], bs[i]);
  Vec3IP.normalize(cs[i]);
  Vec3IP.scale(cs[i], 5);
}

cs.forEach(function(v, i) {
  webglBuffer[i*3+0] = v.x;
  webglBuffer[i*3+1] = v.y;
  webglBuffer[i*3+2] = v.z;
});

var compute = stopMeasuringTime();
var total = alloc + compute;
console.log("XYZInPlace", alloc, compute, total);