var startOfMeasuredTime = 0;
function startMeasuringTime() {
  startOfMeasuredTime = (new Date()).getTime();
}

function stopMeasuringTime(msg) {
  var now = (new Date()).getTime();

  var seconds = (now - startOfMeasuredTime);

  if (msg) {
    if (seconds < 10) seconds = "  " + seconds;
    else if (seconds < 100) seconds = " " + seconds;
    console.log(seconds + "ms for " + msg);
  }
  return seconds;
}

function Vec3N(x, y, z) {
  this.x = x;
  this.y = y;
  this.z = z;
  return this;
}

Vec3N.prototype.added = function(b) {
  return new Vec3N(this.x + b.x, this.y + b.y, this.z + b.z);
}

Vec3N.prototype.normalize = function() {
  var len = Math.sqrt(this.x * this.x + this.y * this.y + this.z * this.z);
  if (len > 0) {
    this.x /= len;
    this.y /= len;
    this.z /= len;
  }
  return this;
}

Vec3N.prototype.scale = function(f) {
  this.x *= f;
  this.y *= f;
  this.z *= f;
}

var numVertices = 100000;

startMeasuringTime();

var xyzNaive1 = new Array();
var xyzNaive2 = new Array();
var xyzNaive3 = new Array();
var xyzNaiveWebglBuffer = new Float32Array(numVertices*3);

for(var i=0; i<numVertices; i++) {
  xyzNaive1[i] = new Vec3N(1, 2, 3);
  xyzNaive2[i] = new Vec3N(4, 5, 6);
  xyzNaive3[i] = new Vec3N(0, 0, 0);
}

var alloc = stopMeasuringTime();
startMeasuringTime();

var as = xyzNaive1;
var bs = xyzNaive2;
var cs = xyzNaive3;
var webglBuffer = xyzNaiveWebglBuffer;

for(var i=0; i<numVertices; i++) {
  cs[i] = as[i].added(bs[i]);
  cs[i].normalize();
  cs[i].scale(5);
}

cs.forEach(function(v, i) {
  webglBuffer[i*3+0] = v.x;
  webglBuffer[i*3+1] = v.y;
  webglBuffer[i*3+2] = v.z;
});

var compute = stopMeasuringTime();
var total = alloc + compute;
console.log("XYZNaive", alloc, compute, total);